Imports System.Net

Module Module1

    Dim listener As HttpListener

    Sub Main()
        listener = New HttpListener
        listener.Prefixes.Add("http://127.0.0.1:9800/")
        listener.Start()

        Dim i As Integer
        For i = 1 To 20
            listener.BeginGetContext(New AsyncCallback(AddressOf request), listener)
        Next

        Console.WriteLine("The built in HTTP Server is accepting incoming SMS messages")
        Console.ReadLine()
    End Sub

    Private Sub request(ByVal result As IAsyncResult)
        If listener Is Nothing Then Return

        Dim context As HttpListenerContext
        context = listener.EndGetContext(result)
        listener.BeginGetContext(New AsyncCallback(AddressOf request), listener)
        processrequest(context)
        context.Response.Close()
    End Sub

    Private Sub processrequest(ByVal context As HttpListenerContext)
        Dim sender As String
        sender = context.Request.QueryString("sender")
        Dim msg As String
        msg = context.Request.QueryString("msg")
        MsgBox(sender + " has sent the following SMS: " + msg)

        Dim response As String
        response = "{SMS:TEXT}{}{+1234657}{" + sender + "}{Thank you for your message}"

        Dim Buffer() As Byte = {}
        Buffer = System.Text.Encoding.UTF8.GetBytes(response)
        context.Response.ContentLength64 = Buffer.Length
        context.Response.ContentType = "text/html; charset=utf-8"
        context.Response.OutputStream.Write(Buffer, 0, Buffer.Length)
        context.Response.Close()
    End Sub

End Module
